import Vue from 'vue'
import Vuex from 'vuex'

Vue.use(Vuex)

export default new Vuex.Store({
  state: {
    token: 0,
    user_id: null,
    userinfo: {},
    is_login: false,
    invite_code: ""
  },
  mutations: {
    set_token(state, token) {
      wx.setStorageSync('token', token)
      state.token = token
    },
    set_login(state) {
      wx.setStorageSync('is_login', true)
      state.is_login = true
    },
    set_invite_code(state, code) {
      state.invite_code = code
      wx.setStorageSync('code', code)
    },
    set_userinfo(state, userinfo) {
      state.userinfo = userinfo
      wx.setStorageSync('userinfo', userinfo)
    }
  },
  getters: {
    get_token(state) {
      return state.token
    },
    get_login_status(state) {
      return state.is_login
    },
    get_userinfo(state) {
      return state.userinfo
    },
    get_invite_code(state) {
      return state.invite_code
    }
  },

})
